-- Copyright 2024 by Todd Hundersmarck (ThundR)
-- All Rights Reserved

THStateControlSystem = {}
local THStateControlSystem_mt = THUtils.createClass(THStateControlSystem, THAbstractSystem)
local debugFlagId = THDebugUtil.createDebugFlag("THStateControlSystem")
THStateControlSystem.debugFlagId = debugFlagId
function THStateControlSystem.new(rootEnv, dataKey, modName, customMt)
    dataKey = dataKey or THStateControlSystem.DATA_KEY
    modName = modName or THStateControlSystem.MOD_NAME
    customMt = customMt or THStateControlSystem_mt
    local self = THAbstractSystem.new(rootEnv, dataKey, modName, customMt)
    if self ~= nil then
        self.thFruitTypeManager = rootEnv.thFruitTypeManager
        self.thFillTypeManager = rootEnv.thFillTypeManager
        self.addUnitsMod = rootEnv.addUnitsMod
        self.additionalUnits = rootEnv.additionalUnits
        return self
    end
end
function THStateControlSystem.newModule(rootEnv, modData)
    if _G.g_thStateControlSystem ~= nil then
        THUtils.warningMsg("Module %q already loaded", THStateControlSystem.DATA_KEY)
    else
        THStateControlSystem.MOD_NAME = modData.name
        THStateControlSystem.DATA_KEY = "stateControlSystem"
        local self = THStateControlSystem.new(rootEnv)
        if self ~= nil then
            _G.g_thStateControlSystem = self
            source(self.modPath .. "scripts/objects/THStorageTransfer.lua")
            self.thSpecManager:addSpecialization("placeable", self.dataKey, "THPlaceableStateControl", self.modName, "scripts/placeables/specializations/THPlaceableStateControl.lua")
            return self
        end
    end
end